﻿;/////////////////////////////////////////////////////////////////////////////////
;Demo of the OOP class for implementing various kinds of stack.

;nxSoftware.

;Demonstrates some of the methods exposed by the 'StructuredStackObject' class.
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "stackClass.pbi"


;Declare our test structure.
  Structure _testStructure
    str1.s
    str2.s
    a.l
    b.w
  EndStructure

;Define and initialise 2 variables of this structured type.
;NOTE THAT (as explained in the user guide) string fields must be placed before all
;other fields.
  TEST._testStructure
    TEST\str1 = "Mule!"
    TEST\str2 = "ASS!"
    TEST\a = 100
    TEST\b = 40
  newTest._testStructure
    newTest\str1 = "Bananas..."
    newTest\str2 = "...are not the only fruit!"
    newTest\a = 1000
    newTest\b = 10

;Let us use a structured stack to swap the structures above.

;Create a stack object with room for 2 elements.
  MyStackObject.StructuredStackObject
  MyStackObject = NewStructuredStack(2, SizeOf(_testStructure), 2)  ;This last 2 denotes that there are two string fields.

If MyStackObject ;Always check that the object was created successfully.
  ;Push the first structure.
    MyStackObject\Push(TEST)
  ;Push the second structure.
    MyStackObject\Push(newTest)

  ;There should be 2 elements currently pushed on the stack.
    Debug "There are " + Str(MyStackObject\NumberOfElementsPushed()) + " elements pushed on the stack."

  ;Now swap the original structures by popping in the reverse order.
    MyStackObject\Pop(TEST)
    MyStackObject\Pop(newTest)

;Check. The second structure variable should contain the fields from the first structure.
  Debug newTest\str1
  Debug newTest\str2
  Debug newTest\a
  Debug newTest\b
  

;Destroy the stack once it is no longer required.
  MyStackObject\Destroy()

Else
  MessageRequester("Error :", "There was a memory allocation problem creating the stack object.")
EndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3