﻿;/////////////////////////////////////////////////////////////////////////////////
;An OOP class for implementing a simple stack.

;nxSoftware.
;January 2010.

;Header file.
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-Class interfaces.

  ;The following interface contains the base class methods.
    Interface StackObject_baseclass
      NumberOfElementsPushed.i()
      SizeOfStack.i()
    EndInterface

  ;The following interface (inheriting from the base class) contains the additional methods
  ;required to implement a basic stack object.
    Interface StackObject Extends StackObject_baseclass
      Destroy()
      Peek.i(index)
      Pop.i()
      Push.i(value)
      ResetStack()
      ResizeStack.i(NumElements)
    EndInterface 

  ;The following interface (inheriting from the base class) contains the additional methods
  ;required to implement a structured stack object.
    Interface StructuredStackObject Extends StackObject_baseclass
      Destroy()
      Peek.i(index, ptrStructure)
      Pop(ptrStructure=0)
      Push.i(ptrStructure)
      ResetStack()
      ResizeStack.i(NumElements)
    EndInterface 
;/////////////////////////////////////////////////////////////////////////////////


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3
; EnableXP